using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.Runtime.Serialization;
using Microsoft.ServiceModel.Samples.Syndication;
namespace Microsoft.ServiceModel.Samples.Syndication
{
    [DataContract(Name=FeedConstants.FeedItem, Namespace= FeedConstants.FeedNamespace)]
    public class Task 
    {
        string title;
        TaskStatus status;
        DateTime dueDate;
        DateTime etaDate;
        string assignedTo;
        string createdBy;
        DateTime createdOn;
        DateTime lastUpdated;
        TaskVisibility visibility;
        List<FeedCategory> categories;
        string description;
        string id;

        public Task() 
        {
            
        }
        public Task(string title, TaskStatus status, DateTime dueDate, DateTime createdOn, string createdBy, string assignedTo, TaskVisibility visibility, string id)
        {
            this.title = title;
            this.description = "Task: " + title;
            this.status = status;
            this.dueDate = dueDate;
            this.createdOn = createdOn;
            this.createdBy = createdBy;
            this.assignedTo = assignedTo;
            this.visibility = visibility;
            this.lastUpdated = createdOn;
            this.id = id;
        }

        [DataMember(Name = FeedConstants.ItemId, Order=2)]
        public string Id
        {
            get
            {
                return this.id;
            }
            set
            {
                id = value;
            }
        }

        [DataMember(Name=FeedConstants.ItemAuthor,Order=5)]
        public string CreatedBy
        {
            get
            {
                return this.createdBy;
            }
            set
            {
                createdBy = value;
            }
        }
        [DataMember(Name=FeedConstants.ItemTitle, Order=1)]
        public string Title
        {
            get
            {
                return this.title;
            }
            set
            {
                title = value;
            }
        }
        [DataMember(Name = FeedConstants.ItemContent,Order=2)]
        public string Description
        {
            get
            {
                return this.description;
            }
            set
            {
                this.description = value;
            }
        }

        [DataMember(Order=20)]
        public string AssignedTo
        {
            get
            {
                return this.assignedTo;
            }
            set
            {
                assignedTo = value;
            }
        }
        [DataMember(Order=21)]
        public TaskStatus Status
        {
            get
            {
                return this.status;
            }
            set
            {
                status = value;
            }
        }
        [DataMember(Order=22)]
        public DateTime DueDate
        {
            get
            {
                return this.dueDate;
            }
            set
            {
                dueDate = value;
            }
        }
        [DataMember(Order=23)]
        public DateTime EtaDate
        {
            get
            {
                return this.etaDate;
            }
            set
            {
                etaDate = value;
            }
        }
        [DataMember(Name = FeedConstants.ItemPublishDate, Order=3)]
        public DateTime CreatedOn
        {
            get
            {
                return this.createdOn;
            }
            set
            {
                createdOn = value;
            }
        }
        [DataMember(Name = FeedConstants.ItemLastUpdated, Order = 4)]
        public DateTime LastUpdated
        {
            get
            {
                return this.lastUpdated;
            }
            set
            {
                lastUpdated = value;
            }
        }
        
        public TaskVisibility Visibility
        {
            get
            {
                return this.visibility;
            }
            set
            {
                this.visibility = Visibility;
            }
        }

        [DataMember(Name=FeedConstants.ItemCategories,Order=6)]
        List<FeedCategory> Categories
        {
            get
            {
                if (this.categories == null)
                {
                    this.categories = new List<FeedCategory>(1);
                    this.categories.Add(new FeedCategory("http://contoso.com/tasklist/visibility", this.Visibility.ToString()));
                    
                }
                return this.categories;
            }
            set
            {
                this.categories = value;
            }
        }
    }
    public enum TaskStatus
    {
        NotStarted,
        InProgress,
        Completed,
    }
    public enum TaskVisibility
    {
        AssignedTo,
        CreatorAndAssignedTo,
        Everyone,
    }
}
