using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using Microsoft.ServiceModel.Samples.Syndication;
namespace Microsoft.ServiceModel.Samples.Syndication
{
[ServiceContract]
public class TaskListService
{
    [OperationContract]
    ContentFeed<Task> GetTaskList()
    {
        
        ContentFeed<Task> feed = new ContentFeed<Task>();
        feed.FeedItems = GenerateTaskList();
        feed.FeedAuthor = "wcfuser@contoso.com";
        feed.FeedTitle = "WCF Task List!";
        feed.FeedDescription = "A sample showing how to use custom feed item types";
        feed.FeedId="http://www.contoso.com/tasklist";
        feed.FeedWebPageLink = "http://www.contoso.com/tasklist"; 
        return feed;
    }
        ItemList<Task> GenerateTaskList()
        {
            ItemList<Task> list = new ItemList<Task>();
            Task task1 = new Task(
                "Write WCF apps",
                TaskStatus.InProgress,
                new DateTime(2006, 07, 07),
                new DateTime(2006, 06, 01),
                "wcfuser1@contoso.com",
                "wcfdev1@contoso.com",
                TaskVisibility.Everyone,
                "http://contoso.com/tasklist/task1");

            Task task2 = new Task(
                "Test WCF apps",
                TaskStatus.NotStarted,
                new DateTime(2006, 07, 17),
                new DateTime(2006, 06, 02),
                "wcfuser1@contoso.com",
                "wcftest1@contoso.com",
                TaskVisibility.Everyone,
                "http://contoso.com/tasklist/task2");

            Task task3 = new Task(
                "Document WCF apps",
                TaskStatus.NotStarted,
                new DateTime(2006, 09, 01),
                new DateTime(2006, 06, 03),
                "wcfuser1@contoso.com",
                "wcfpm1@contoso.com",
                TaskVisibility.Everyone,
                "http://contoso.com/tasklist/task3");

            Task task4 = new Task(
                "Walk dog",
                TaskStatus.NotStarted,
                new DateTime(2006, 06, 25),
                new DateTime(2010, 06, 04),
                "wcfuser1@contoso.com",
                "wcfuser2@contoso.com",
                TaskVisibility.AssignedTo,
                "http://contoso.com/tasklist/task4");

            Task task5 = new Task(
                "Wash car",
                TaskStatus.NotStarted,
                new DateTime(2006, 06, 26),
                new DateTime(2010, 06, 05),
                "wcfuser1@contoso.com",
                "wcfuser2@contoso.com",
                TaskVisibility.CreatorAndAssignedTo,
                "http://contoso.com/tasklist/task5");
            list.Add(task1);
            list.Add(task2);
            list.Add(task3);
            list.Add(task4);
            list.Add(task5);
            return list;

        }
    }
}
