using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.OleDb;
using Microsoft.ServiceModel.Samples.Syndication;
namespace Microsoft.ServiceModel.Samples.Syndication
{
    class NWindQuery
    {
        
        private static string ConnectionString;
        private static string CustomersQuery = "SELECT ('http://contoso.com/samples/nwind/'+Customers.CustomerID) AS ItemId, (Customers.ContactName+' ('+Customers.CompanyName+')') AS ItemTitle, Customers.Country AS Category_Country, Customers.Phone, Customers.Address, Customers.City, Customers.Region, Customers.PostalCode, Customers.Country, '2006/6/4' As ItemPublishDate, '2006/6/05' As ItemLastUpdated, (Customers.ContactName & ' from ' & Customers.Country) As ItemContent FROM Customers";
        private static string CustomerOrdersQuery = "SELECT ( 'http://contoso.com/samples/nwind/'& Orders.OrderId ) AS ItemId, ('Order #' & Orders.OrderId) As ItemTitle, Employees.LastName & '@contoso.com' AS ItemAuthor, Orders.OrderDate AS ItemPublishDate, Orders.OrderDate AS ItemLastUpdated, Orders.RequiredDate, ('Order shipped on ' & Orders.ShippedDate) As ItemContent, (Employees.FirstName + ' ' +  Employees.LastName) AS Category_Employee FROM Employees INNER JOIN Orders ON Employees.EmployeeID = Orders.EmployeeID WHERE Orders.CustomerId=@customerId";
        static NWindQuery()
        {
            NWindQuery.ConnectionString = System.Configuration.ConfigurationSettings.AppSettings["connectionString"];
        }
        internal static DataTable ExecCustomersQuery()
        {
            DataTable table = GetEmptyDataTable();
            OleDbConnection conn = new OleDbConnection(ConnectionString);
            OleDbDataAdapter adapter = new OleDbDataAdapter(CustomersQuery, conn);
            conn.Open();
            adapter.Fill(table);
            conn.Close();
            return table;


        }
        internal static DataTable ExecCustomerOrdersQuery(string customerId)
        {
            DataTable table = GetEmptyDataTable();
            OleDbConnection conn = new OleDbConnection(ConnectionString);
            OleDbDataAdapter adapter = new OleDbDataAdapter(CustomerOrdersQuery, conn);
            adapter.SelectCommand.Parameters.Add("@customerId",OleDbType.Char,5).Value = customerId;
            conn.Open();
            adapter.Fill(table);
            conn.Close();
            return table;
        }
        static DataTable GetEmptyDataTable()
        {
            DataTable table = new DataTable("Northwind Customers and Orders", "http://nwind/customers");
            table.ExtendedProperties.Add(FeedConstants.FeedId, "http://contoso.com/Feeds/NWind");
            table.ExtendedProperties.Add(FeedConstants.FeedDescription, "A list of Northwind Customers and Orders");
            table.ExtendedProperties.Add(FeedConstants.FeedWebPageLink, "http://www.contoso.com/CustomerFeed"); 
            // Edit the email address below
            table.ExtendedProperties.Add(FeedConstants.FeedAuthor, "yourname@domain.com");
            table.ExtendedProperties.Add(FeedConstants.FeedCopyright, "Copyright 2006 You Name");
            // To give this feed a logo, uncomment the line below and edit the URL to point to the image
            //table.ExtendedProperties.Add(FeedConstants.FeedImage, "http://link-to-your-image/logo.gif");
            
            return table;

        }
    }
}
