using System;
using System.ServiceModel;
using System.ServiceModel.Description;
namespace Microsoft.ServiceModel.Samples.Syndication
{
    class Program
    {
        static void Main(string[] args)
        {
            //host NWind service
            ContentFeedHost host = new ContentFeedHost(
                typeof(NWindService),
                new Uri("http://localhost:8071/NWind"),
                new Uri("net.tcp://localhost:8061/NWind"));
            //endpoints are added in code
            // SOAP endpoint
            ServiceEndpoint soap = host.AddServiceEndpoint(typeof(NWindService), new NetTcpBinding(), "soap");
            // RSS endpoint
            host.AddRssEndpoint(typeof(NWindService), "rss");
            // ATOM endpoint
            ServiceEndpoint atom = host.AddAtomEndpoint(typeof(NWindService), "atom");
            host.Open();
            Console.WriteLine("NWind service ready. Press [Enter] to exit");
            Console.ReadLine();
            host.Close();
        }
    }
}
