using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using Microsoft.ServiceModel.Samples.Syndication;
namespace Microsoft.ServiceModel.Samples.Syndication
{
    [ServiceContract]
    public class ItemListService
    {
        internal const string ItemNs = "http://contoso.com/itemlist";

        [OperationContract]
        ContentFeed<FeedItem> GetItemList()
        {
            
            ContentFeed<FeedItem> feed = new ContentFeed<FeedItem>();
            feed.FeedAuthor = "wcfuser@contoso.com";
            feed.FeedTitle = "WCF Item List!";
            feed.FeedDescription = "A sample showing how to use FeedItem directly";
            feed.FeedId = ItemNs;
            feed.FeedWebPageLink = "http://www.contoso.com/itemlist";

            feed.FeedItems = GenerateItemList();

            return feed;
        }
        ItemList<FeedItem> GenerateItemList()
        {
            ItemList<FeedItem> list = new ItemList<FeedItem>();

            FeedItem item1 = new FeedItem();
            item1.ItemTitle = "This is item 1";
            //treat the content of this item as HTML and do not escape it
            item1.ItemContent = new ItemContent("<div xmlns='http://www.w3.org/1999/xhtml'>This unescaped string item is <b>very</b> <span style='color:blue'>cool!</span><br/> Note that RSS doesn't support unescaped XML/HTML tags within description while Atom does.</div>", true);
            item1.ItemPublishDate = DateTime.Parse("6/1/2006");
            item1.ItemLastUpdated = item1.ItemPublishDate.Value.AddDays(1);
            item1.ItemCategories.Add(new FeedCategory("http://contoso.com/categories/", "Everyone"));
            item1.ItemExtensions.Add(new ObjectExtension("Status", "InProgress", ItemNs));
            item1.ItemId = "http://contoso.com/feed/items/7333830f-a644-430f-8476-ce697d27d38e";
            
            list.Add(item1);
            
            FeedItem item2 = new FeedItem();
            item2.ItemTitle = "This is item 2";
            //treat the content of this item as a string and escape it
            item2.ItemContent = new ItemContent("<div>This escaped string item is <i>quite</i> <span style='color:red'>hot!</span><br/>Many readers will interpret this as HTML even when it's escaped. Escaped strings are your best bet for HTML content in both RSS and Atom.</div>", false);
            item2.ItemPublishDate = DateTime.Parse("6/2/2006");
            item2.ItemLastUpdated = item2.ItemPublishDate.Value.AddDays(1);
            item2.ItemCategories.Add(new FeedCategory("http://contoso.com/categories/", "Owner"));
            item2.ItemExtensions.Add(new ObjectExtension("Status", "Not Started", ItemNs));
            item2.ItemId = "http://contoso.com/feed/items/8123830f-a644-430f-8476-ce697d27d592";
            
            list.Add(item2);
            
            return list;
        }
    }
}
