using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.Runtime.Serialization;
using Microsoft.ServiceModel.Samples.Syndication;
namespace Microsoft.ServiceModel.Samples.Syndication
{
    [XmlType(TypeName=FeedConstants.FeedItem, Namespace= FeedConstants.FeedNamespace)]
    public class Task 
    {
        string title;
        TaskStatus status;
        DateTime dueDate;
        DateTime etaDate;
        string assignedTo;
        string createdBy;
        DateTime createdOn;
        DateTime lastUpdated;
        TaskVisibility visibility;
        List<FeedCategory> categories;
        string id;
        string description;
        public const string TaskNs="http://contoso.com/tasklist";

        public Task() 
        {
            
        }
        public Task(string title, TaskStatus status, DateTime dueDate, DateTime createdOn, string createdBy, string assignedTo, TaskVisibility visibility, string id)
        {
            this.title = title;
            this.description = "Task: " + title;
            this.status = status;
            this.dueDate = dueDate;
            this.createdOn = createdOn;
            this.lastUpdated = createdOn;
            this.createdBy = createdBy;
            this.assignedTo = assignedTo;
            this.visibility = visibility;
            this.id = id;
        }
        [XmlElement(ElementName=FeedConstants.ItemAuthor)]
        public string CreatedBy
        {
            get
            {
                return this.createdBy;
            }
            set
            {
                createdBy = value;
            }
        }
        [XmlElement(ElementName = FeedConstants.ItemId)]
        public string Id
        {
            get
            {
                return this.id;
            }
            set
            {
                id = value;
            }
        }

        [XmlElement(ElementName = FeedConstants.ItemTitle)]
        public string Title
        {
            get
            {
                return this.title;
            }
            set
            {
                title = value;
            }
        }
        [XmlElement(ElementName = FeedConstants.ItemContent)]
        public string Description
        {
            get
            {
                return this.description;
            }
            set
            {
                this.description = value;
            }
        }
        [XmlElement(Namespace=Task.TaskNs)]
        public string AssignedTo
        {
            get
            {
                return this.assignedTo;
            }
            set
            {
                assignedTo = value;
            }
        }
        [XmlElement(Namespace = Task.TaskNs)]
        public TaskStatus Status
        {
            get
            {
                return this.status;
            }
            set
            {
                status = value;
            }
        }
        [XmlElement(Namespace = Task.TaskNs)]
        public DateTime DueDate
        {
            get
            {
                return this.dueDate;
            }
            set
            {
                dueDate = value;
            }
        }
        [XmlElement(Namespace = Task.TaskNs)]
        public DateTime EtaDate
        {
            get
            {
                return this.etaDate;
            }
            set
            {
                etaDate = value;
            }
        }
        [XmlElement(ElementName = FeedConstants.ItemPublishDate)]
        public DateTime CreatedOn
        {
            get
            {
                return this.createdOn;
            }
            set
            {
                createdOn = value;
            }
        }
        [XmlIgnore]
        public TaskVisibility Visibility
        {
            get
            {
                return this.visibility;
            }
            set
            {
                this.visibility = Visibility;
            }
        }

        [XmlArray(ElementName = FeedConstants.ItemCategories)]
        public List<FeedCategory> Categories
        {
            get
            {
                if (this.categories == null)
                {
                    this.categories = new List<FeedCategory>(1);
                    this.categories.Add(new FeedCategory("http://contoso.com/tasklist/visibility", this.Visibility.ToString()));

                }
                return this.categories;
            }
            set
            {
                this.categories = value;
            }
        }
    }
    public enum TaskStatus
    {
        NotStarted,
        InProgress,
        Completed,
    }
    public enum TaskVisibility
    {
        AssignedTo,
        CreatorAndAssignedTo,
        Everyone,
    }
}
