Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.ServiceModel
Imports Microsoft.ServiceModel.Samples.Syndication

Module Module1
    '*
    '* This program hosts a syndication service in a console application
    '* It defines an Atom and an RSS endpoint in code
    '* Two additional endpoints have been added in app.config.
    '* To test the service, point an RSS/Atom reader (e.g. Internet Explorer 7) to
    '* http://baseserviceaddress/endpoint/methodname 
    '* e.g. http://localhost:8077/ItemListService/rss1/GetItemList
    '*
    Public Sub Main()
        ' Use ContentFeedHost to host your service

        Dim host As ContentFeedHost = New ContentFeedHost( _
                GetType(ItemListService), _
                New Uri("http://localhost:8077/ItemListService"))

        ' Endpoints defined in code
        host.AddRssEndpoint(GetType(ItemListService), "rss1")
        host.AddAtomEndpoint(GetType(ItemListService), "atom1")

        ' Run service
        host.Open()
        Console.WriteLine("Service started ...")
        Console.WriteLine("RSS endpoint at http://localhost:8077/ItemListService/rss1/GetItemList")
        Console.WriteLine("Atom endpoint at http://localhost:8077/ItemListService/atom1/GetItemList")
        Console.WriteLine("Press [Enter] to exit")
        Console.ReadLine()
        host.Close()

    End Sub
End Module
