using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;
using System.ServiceModel;
using System.ServiceModel.Configuration;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;
using System.ServiceModel.Description;
namespace Microsoft.ServiceModel.Samples.Syndication
{
    public class MessageTransformBehavior : IEndpointBehavior
    {
        Type transformProviderType;
        public MessageTransformBehavior()
        {
            
        }
        public MessageTransformBehavior(Type transformProviderType)
        {
            this.transformProviderType = transformProviderType;
        }
        #region IEndpointBehavior Members

        public void AddBindingParameters(ServiceEndpoint serviceEndpoint, BindingParameterCollection bindingParameters)
        {
            
        }

        public void ApplyClientBehavior(ServiceEndpoint serviceEndpoint, ClientRuntime behavior)
        {
            throw new NotSupportedException("MessageTransformBehavior is supported only on the service side");
        }

        public void ApplyDispatchBehavior(ServiceEndpoint serviceEndpoint, EndpointDispatcher endpointDispatcher)
        {
            TraceHelper.TraceMethod(System.Diagnostics.TraceEventType.Verbose, "MessageTransformBehavior.ApplyDispatchBehavior");
            if (this.transformProviderType == null)
            {
                throw new InvalidOperationException("transformProvider type cannot be null. Please set the TransformProvider property or pass in the transformProviderType to MessageTransformBehavior constructor");
            }
            MessageTransform transform = new MessageTransform(this.transformProviderType);
            endpointDispatcher.DispatchRuntime.MessageInspectors.Add(transform);

        }

        public void Validate(ServiceEndpoint serviceEndpoint)
        {
            //PoxHttpBinding binding = serviceEndpoint.Binding as PoxHttpBinding;
            //if (binding != null && this.transformProviderType != null)
            //{
            //    BindingElementCollection becol = binding.CreateBindingElements();
            //    foreach (BindingElement be in becol)
            //    {
            //        PoxMessageEncodingBindingElement poxbe = be as PoxMessageEncodingBindingElement;
            //        if (poxbe != null)
            //        {
                        
            //            IFormatTransformProvider transformer = Activator.CreateInstance(this.transformProviderType) as IFormatTransformProvider;
            //            if (transformer != null)
            //            {
            //                poxbe.WriteContentType=  transformer.ContentType;
            //            }
            //            break;
            //        }
            //    }
            //    CustomBinding cb=new CustomBinding(becol);
            //    serviceEndpoint.Binding=cb;
            //}
            
        }

        #endregion
    }
  
}
