
namespace Microsoft.ServiceModel.Samples.Syndication.Configuration
{

    using System;
    using System.Collections.Generic;
    using System.Text;
    using System.Configuration;
    using System.ServiceModel.Configuration;
    using System.ServiceModel.Channels;
    using Microsoft.ServiceModel.Samples.Syndication;
    public class PoxHttpBindingConfigurationElement : System.ServiceModel.Configuration.StandardBindingElement 
    {
        public PoxHttpBindingConfigurationElement() : this(null)
        {
        }
        public PoxHttpBindingConfigurationElement(string name) : base(name)
        {
        }

        protected override void InitializeFrom(Binding binding)
        {
            base.InitializeFrom(binding);
            if (binding == null)
            {
                throw new ArgumentNullException("binding");
            }
            if (!(binding is PoxHttpBinding))
            {
                throw new ArgumentException("binding must be a PoxHttpBinding");
            }
            PoxHttpBinding pox=binding as PoxHttpBinding;
            this.ContentType = pox.ContentType;
        }
        protected override void OnApplyConfiguration(Binding binding)
        {
            if (binding == null)
            {
                throw new ArgumentNullException("binding");
            }
            if (!(binding is PoxHttpBinding))
            {
                throw new ArgumentException("binding must be a PoxHttpBinding");
            }
            PoxHttpBinding pox = binding as PoxHttpBinding;
            pox.ContentType = this.ContentType;

        }

        // Properties
        protected override Type BindingElementType
        {
            get
            {
                return typeof(PoxHttpBinding);
            }
        }
        [ConfigurationProperty(ConfigurationStrings.ContentTypeName,DefaultValue=HttpConstants.RssContentType)]
        public string ContentType
        {
            get
            {
                return (string)base[ConfigurationStrings.ContentTypeName];
            }
            set
            {
                base[ConfigurationStrings.ContentTypeName] = value;
            }

        }
        protected override ConfigurationPropertyCollection Properties
        {
            get
            {
                ConfigurationPropertyCollection properties = base.Properties;
                properties.Add(new ConfigurationProperty(ConfigurationStrings.ContentTypeName,
                    typeof(String), HttpConstants.RssContentType, null, null, ConfigurationPropertyOptions.None));
                return properties;
            }
        }    
    }

    public class PoxHttpBindingSection : System.ServiceModel.Configuration.StandardBindingCollectionElement<PoxHttpBinding, PoxHttpBindingConfigurationElement>
    {


    }

}
