#region Copyright Notice
// ----------------------------------------------------------------------------
// Copyright (C) 2005 Microsoft Corporation, All rights reserved.
// ----------------------------------------------------------------------------

// Author: VipulM
#endregion

namespace Microsoft.ServiceModel.Samples.Syndication.Configuration
{
    using System;
    using System.ComponentModel;
    using System.Text;
    using System.ServiceModel;
    using System.ServiceModel.Channels;
    using System.ServiceModel.Configuration;
    using System.Configuration;

    public class PoxMessageEncodingBindingSection : 
        BindingElementExtensionElement 
    {
        public override Type BindingElementType
        {
            get
            {
                return typeof(PoxMessageEncodingBindingElement);
            }
        }

        protected override BindingElement CreateBindingElement()
        {
            return new PoxMessageEncodingBindingElement(this.WriteEncoding, 
                    this.WriteContentType, this.ReadContentType);
        }

        //public new string ConfiguredSectionName
        //{
        //    get
        //    {
        //        return ConfigurationStrings.PoxSectionName;
        //    }
        //}

        [ConfigurationProperty(ConfigurationStrings.ReadContentTypeName,
            DefaultValue = ConfigurationStrings.DefaultReadContentType)]
        public string ReadContentType
        {
            get
            {
                return (string)base[ConfigurationStrings.ReadContentTypeName];
            }

            set
            {
                base[ConfigurationStrings.ReadContentTypeName] = value;
            }
        }

        [ConfigurationProperty(ConfigurationStrings.WriteContentTypeName,
            DefaultValue = ConfigurationStrings.DefaultWriteContentType)]
        public string WriteContentType
        {
            get
            {
                return (string)base[ConfigurationStrings.WriteContentTypeName];
            }

            set
            {
                base[ConfigurationStrings.WriteContentTypeName] = value;
            }
        }

        

        [ConfigurationProperty(ConfigurationStrings.WriteEncodingName,
            DefaultValue = ConfigurationStrings.DefaultWriteEncoding)]
        public string WriteEncoding
        {
            get
            {
                return (string)base[ConfigurationStrings.WriteEncodingName];
            }

            set
            {
                base[ConfigurationStrings.WriteEncodingName] = value;
            }
        }
    }


}
