using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;
using System.Xml.Serialization;
namespace Microsoft.ServiceModel.Samples.Syndication
{
    [DataContract(Name = FeedConstants.FeedItem, Namespace = FeedConstants.FeedNamespace)]
    [XmlType(TypeName=FeedConstants.FeedItem, Namespace=FeedConstants.FeedNamespace)]
    public class FeedItem : IFeedItem
    {
        private string titleField;
        private string linkField;
        private ItemContent contentField;
        private Nullable<DateTime> pubDateField;
        private string guidField;
        private string authorField;
        private string commentsField;
        private List<FeedCategory> categoriesField;
        private ContentExtensions extensionsField;
        private Nullable<DateTime> lastUpdatedField;
        public FeedItem()
        {
            //set some defaults
            this.ItemCategories = new List<FeedCategory>();
            this.ItemExtensions = new ContentExtensions();
            this.ItemPublishDate = DateTime.UtcNow;
            this.ItemLastUpdated = this.ItemLastUpdated;

        }
        [XmlElement(ElementName=FeedConstants.ItemId,Order=2)]
        [DataMember(Name = FeedConstants.ItemId, Order = 2)]
        public virtual string ItemId
        {
            get
            {
                return this.guidField;
            }
            set
            {
                this.guidField = value;
            }
        }
        [XmlElement(ElementName = FeedConstants.ItemTitle, Order = 0)]
        [DataMember(Name = FeedConstants.ItemTitle, Order = 0)]
        public virtual string ItemTitle
        {
            get
            {
                return this.titleField;
            }
            set
            {
                this.titleField = value;
            }
        }
        [XmlElement(ElementName = FeedConstants.ItemWebPageLink, Order = 1)]
        [DataMember(Name = FeedConstants.ItemWebPageLink, Order = 1)]
        public virtual string ItemWebPageLink
        {
            get
            {
                return this.linkField;
            }
            set
            {
                this.linkField = value;
            }
        }
        [XmlElement(ElementName = FeedConstants.ItemContent, Order = 5)]
        [DataMember(Name = FeedConstants.ItemContent, Order = 5)]
        public virtual ItemContent ItemContent
        {
            get
            {
                return this.contentField;
            }
            set
            {
                this.contentField = value;
            }
        }

        [XmlElement(ElementName = FeedConstants.ItemPublishDate, Order = 3)]
        [DataMember(Name = FeedConstants.ItemPublishDate, Order = 3)]
        public virtual Nullable<DateTime> ItemPublishDate
        {
            get
            {
                return this.pubDateField;
            }
            set
            {
                this.pubDateField = value;
            }
        }
        [XmlElement(ElementName = FeedConstants.ItemLastUpdated, Order = 4)]
        [DataMember(Name = FeedConstants.ItemLastUpdated, Order = 4)]
        public virtual Nullable<DateTime> ItemLastUpdated
        {
            get
            {
                return this.lastUpdatedField;
            }
            set
            {
                this.lastUpdatedField = value;
            }
        }
        [XmlElement(ElementName = FeedConstants.ItemAuthor, Order = 6)]
        [DataMember(Name = FeedConstants.ItemAuthor, Order = 6)]
        public virtual string ItemAuthor
        {
            get
            {
                return this.authorField;
            }
            set
            {
                this.authorField = value;
            }
        }
        [XmlElement(ElementName = FeedConstants.ItemCommentsLink, Order = 7)]
        [DataMember(Name = FeedConstants.ItemCommentsLink, Order = 7)]
        public virtual string ItemCommentsLink
        {
            get
            {
                return this.commentsField;
            }
            set
            {
                this.commentsField = value;
            }
        }
        [DataMember(Name = FeedConstants.ItemCategories, Order = 8)]
        [XmlArray(ElementName = FeedConstants.ItemCategories, Order = 8)]
        public virtual List<FeedCategory> ItemCategories
        {
            get
            {
                return this.categoriesField;
            }
            set
            {
                this.categoriesField = value;
            }

        }

        [XmlElement(ElementName = FeedConstants.ItemExtensions, Order = 9)]
        [DataMember(Name = FeedConstants.ItemExtensions, Order = 9)]
        public virtual ContentExtensions ItemExtensions
        {
            get
            {
                return this.extensionsField;
            }
            set
            {
                this.extensionsField = value;
            }

        }


    }
}
