using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace Microsoft.ServiceModel.Samples.Syndication
{
    public class XmlExtension : IXmlSerializable
    {
        private XmlElement element;
        #region IXmlSerializable Members

        public XmlExtension(XmlReader reader)
        {
            this.ReadXml(reader);
            
        }
        public XmlExtension(XmlElement element)
        {
            this.element=element;
        }
        public XmlSchema GetSchema()
        {
            return null;
        }

        public void ReadXml(XmlReader reader)
        {
            if (reader == null)
            {
                throw new ArgumentNullException("reader");
            }
            if(reader.NodeType == XmlNodeType.Element)
            {
                this.element = this.GetElementFromReader(reader);
            }
        }

        public void WriteXml(XmlWriter writer)
        {
            if (writer == null)
            {
                throw new ArgumentNullException("writer");
            }
            if(this.element != null)
            {
                this.element.WriteTo(writer);
            }
        }

        #endregion
        public XmlElement Element
        {
            get { return this.element; }
        }

        XmlElement GetElementFromReader(XmlReader reader)
        {
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(reader.ReadOuterXml());
            return doc.DocumentElement;
        }
    }
}
