using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Text;
using System.Web;
using System.ServiceModel.Description;
using System.Reflection;
namespace Microsoft.ServiceModel.Samples.Syndication
{
    public class HttpHelper
    {
        public static Dictionary<string,string> ParseQueryString(string queryString)
        {
            if (queryString == null)
            {
                throw new ArgumentException("query string cannot be null", queryString);
            }
            Dictionary<string,string> dictionary = new Dictionary<string,string>();
            
            if ((queryString.Length > 0) && (queryString[0] == '?'))
                queryString = queryString.Substring(1);

            // parse and populate dictionary
            string[] keyValuePairs = queryString.Split('&');
            foreach (string keyValuePair in keyValuePairs)
            {
                string[] keyValue = keyValuePair.Split('=');
                if (keyValue.Length == 1)
                {
                    dictionary.Add(
                        HttpUtility.UrlDecode(keyValue[0]).ToLowerInvariant(),
                        String.Empty);
                }
                else if (keyValue.Length == 2)
                {
                    dictionary.Add(
                        HttpUtility.UrlDecode(keyValue[0]).ToLowerInvariant(),
                        HttpUtility.UrlDecode(keyValue[1]));
                }
                else
                {
                    // skip for now
                }
            }
            return dictionary;

        }
        public static IContractBehavior GetNoMetadataContractBehavior()
        {
            Assembly assembly = typeof(IEndpointBehavior).Assembly;
            Type t = assembly.GetType("System.ServiceModel.Description.ServiceMetadataContractBehavior");
            PropertyInfo pi = t.GetProperty("MetadataGenerationDisabled");
            IContractBehavior behavior = Activator.CreateInstance(t) as IContractBehavior;
            pi.SetValue(behavior, true, new object[] { });
            return behavior;
        }
    }
}
