using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel.Channels;
using System.ServiceModel;
using Microsoft.ServiceModel.Samples.Syndication.Configuration;
namespace Microsoft.ServiceModel.Samples.Syndication
{
    public class PoxHttpBinding : Binding
    {
        HttpTransportBindingElement httpbe;
        PoxMessageEncodingBindingElement encoderbe;
        public PoxHttpBinding() : this(ConfigurationStrings.DefaultWriteContentType)
        {
        }
        public PoxHttpBinding(string contentType)
        {
            httpbe = new HttpTransportBindingElement();
            httpbe.ManualAddressing = true;
            httpbe.HostNameComparisonMode = HostNameComparisonMode.WeakWildcard;
            encoderbe = new PoxMessageEncodingBindingElement("utf-8", contentType);
        }
        public override BindingElementCollection CreateBindingElements()
        {
            BindingElementCollection becol = new BindingElementCollection();
            becol.Add(this.encoderbe);
            becol.Add(this.httpbe);
            return becol;
        }
        public override string Scheme
        {
            get { return Uri.UriSchemeHttp; }
        }
        public string ContentType
        {
            get { return encoderbe.WriteContentType; }
            set {  encoderbe.WriteContentType = value;  }
        }
    }
}
