#region Copyright Notice
// ----------------------------------------------------------------------------
// Copyright (C) 2005 Microsoft Corporation, All rights reserved.
// ----------------------------------------------------------------------------

// Author: VipulM
#endregion

namespace Microsoft.ServiceModel.Samples.Syndication
{
    using System;
    using System.ServiceModel;
    using System.ServiceModel.Channels;

    //Every MessageEncoder is instantiated via a factory
    public class PoxMessageEncoderFactory : MessageEncoderFactory
    {
        private MessageEncoder encoder;
        private string readContentType;
        private string writeContentType;
        private string writeEncoding;

        internal PoxMessageEncoderFactory(string writeEncoding, 
            string writeContentType, string readContentType)
        {
            this.writeEncoding = writeEncoding;
            this.writeContentType = writeContentType;
            this.readContentType = readContentType;
            this.encoder = new PoxMessageEncoder(this);
        }

        internal string WriteContentType
        {
            get
            {
                return this.writeContentType;
            }
        }

        internal string WriteEncoding
        {
            get
            {
                return this.writeEncoding;
            }
        }

        internal string ReadContentType
        {
            get
            {
                return this.readContentType;
            }
        }

        public override MessageEncoder Encoder
        {
            get 
            { 
                return this.encoder;
            }
        }

        public override MessageVersion MessageVersion
        {
            get 
            { 
                return MessageVersion.Soap12WSAddressingAugust2004;
            }
        }
    }
}
